searchNodes=[{"type":"module","title":"LocationSimulator","doc":"This is main api of library. To start simple call iex&gt; LocationSimulator.start() Or start with your config iex&gt; config = LocationSimulator.default_config() iex&gt; config = Map.put(config, :worker, 1) iex&gt; LocationSimulator.start(config)","ref":"LocationSimulator.html"},{"type":"function","title":"LocationSimulator.default_config/0","doc":"Get default config of library.","ref":"LocationSimulator.html#default_config/0"},{"type":"function","title":"LocationSimulator.start/0","doc":"Start with default config. In this case, library just uses Logger to log data in every event.","ref":"LocationSimulator.html#start/0"},{"type":"function","title":"LocationSimulator.start/1","doc":"Start with config. The config is a map type. Config has info like: %{ worker : 3 , # number of worker will run event : 100 , # number of GPS events will be trigger for a worker interval : 1000 , # this &amp; random_range used for sleep between GPS events, if value is :infinity worker will run forever (you still stop by return {:stop, reason}) random_range : 0 , # 0 mean no random, other positive will be used for generate extra random sleep time callback : MyCallbackModule # your module will handle data } :id is reserved for worker's id. If you need pass your data to callback module you can add that in the config. The config can be change after every event.","ref":"LocationSimulator.html#start/1"},{"type":"module","title":"LocationSimulator.DynamicSupervisor","doc":"DynamicSupervisor, uses for add worker in runtime. Module uses PartitionSupervisor to improve performance when start workers.","ref":"LocationSimulator.DynamicSupervisor.html"},{"type":"function","title":"LocationSimulator.DynamicSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"LocationSimulator.DynamicSupervisor.html#child_spec/1"},{"type":"function","title":"LocationSimulator.DynamicSupervisor.start_link/1","doc":"","ref":"LocationSimulator.DynamicSupervisor.html#start_link/1"},{"type":"function","title":"LocationSimulator.DynamicSupervisor.start_simulator/1","doc":"","ref":"LocationSimulator.DynamicSupervisor.html#start_simulator/1"},{"type":"behaviour","title":"LocationSimulator.Event","doc":"Callback api is a brigde for worker call your code. Has three callback apis: start/2, event/2, stop/2 All these have 2 parameters is config &amp; state. config includes lib's config and your meta data you need pass to module. state is data that is generated by worker. state is an Elixir map with key: :start_time - Unix timestamp the worker start. :success - Number of event success. :failed - Number of event failed. :error - Number of event error :gps - GPS data of current state. :stop_time - Timestamp worker done, only in stop callback api. GPS data is map with key: :timestamp - delta time in milisecond from start event (stored in state with key :start_time). :long - Longitude :lati - Latitude :elev - elevation (meter) Example Please go to example folder in repo","ref":"LocationSimulator.Event.html"},{"type":"callback","title":"LocationSimulator.Event.event/2","doc":"event callback will be trigger every worker generated a new GPS data. Time between event is calculated by interval + random(random_range). If result is {:stop, reason} the worker will stop working.","ref":"LocationSimulator.Event.html#c:event/2"},{"type":"callback","title":"LocationSimulator.Event.start/2","doc":"start event will be trigger when worker start. In this event gps &amp; :end_time won't exist. result return to worker for success is {:ok, new_config}. new_config will be used for next event. if return {:error, reason} the worker will stop working.","ref":"LocationSimulator.Event.html#c:start/2"},{"type":"callback","title":"LocationSimulator.Event.stop/2","doc":"stop will be trigger when worker send all gps event. In this event you have all information for calculating time, distance, speed.","ref":"LocationSimulator.Event.html#c:stop/2"},{"type":"module","title":"LocationSimulator.Gps","doc":"Generate a random location. Get next gps from a location.","ref":"LocationSimulator.Gps.html"},{"type":"function","title":"LocationSimulator.Gps.generate_next_pos/4","doc":"Gets next location from current location.","ref":"LocationSimulator.Gps.html#generate_next_pos/4"},{"type":"function","title":"LocationSimulator.Gps.generate_pos/0","doc":"Generates a random location.","ref":"LocationSimulator.Gps.html#generate_pos/0"},{"type":"module","title":"LocationSimulator.Gpx","doc":"Gpx is a module that provides functions for parsing GPX file.","ref":"LocationSimulator.Gpx.html"},{"type":"function","title":"LocationSimulator.Gpx.read_gpx/1","doc":"","ref":"LocationSimulator.Gpx.html#read_gpx/1"},{"type":"function","title":"LocationSimulator.Gpx.read_string_gpx/1","doc":"","ref":"LocationSimulator.Gpx.html#read_string_gpx/1"},{"type":"module","title":"LocationSimulator.Gpx.GpsPoint","doc":"GpsPoint is a struct that represents a GPS point load from GPX file.","ref":"LocationSimulator.Gpx.GpsPoint.html"},{"type":"type","title":"LocationSimulator.Gpx.GpsPoint.t/0","doc":"Holds GPS point data from GPX file. :lati is latitude. :long is longitude. :elev is elevation. :time is time of GPS point.","ref":"LocationSimulator.Gpx.GpsPoint.html#t:t/0"},{"type":"module","title":"LocationSimulator.LoggerEvent","doc":"Default callback for demo &amp; develop. Just get data from LocationSimulator.Worker and print to console (by Logger).","ref":"LocationSimulator.LoggerEvent.html"},{"type":"module","title":"LocationSimulator.Worker","doc":"Worker is a simulator that use for generating GPS data. Worker will call client follow :callback setting in config. Two start/stop event is used for start or init data and clean if need. event api is used for put GPS data to client. Callbacks are declared in LocationSimulator.Event module.","ref":"LocationSimulator.Worker.html"},{"type":"function","title":"LocationSimulator.Worker.child_spec/1","doc":"Generate child spec for supervisor.","ref":"LocationSimulator.Worker.html#child_spec/1"},{"type":"function","title":"LocationSimulator.Worker.init/1","doc":"Entry point of worker, start event will be fired from here. Init some data and go to loop function for generating GPS data. Root GPS data will be generated in this function.","ref":"LocationSimulator.Worker.html#init/1"},{"type":"function","title":"LocationSimulator.Worker.start_link/1","doc":"Support for starting from supervisor.","ref":"LocationSimulator.Worker.html#start_link/1"},{"type":"module","title":"LocationSimulator.WorkerGpx","doc":"Worker is a simulator that use for generating GPS data. Worker will call client follow :callback setting in config. Two start/stop event is used for start or init data and clean if need. event api is used for put GPS data to client. Callbacks are declared in LocationSimulator.Event module.","ref":"LocationSimulator.WorkerGpx.html"},{"type":"function","title":"LocationSimulator.WorkerGpx.child_spec/1","doc":"Generate child spec for supervisor.","ref":"LocationSimulator.WorkerGpx.html#child_spec/1"},{"type":"function","title":"LocationSimulator.WorkerGpx.init/1","doc":"Entry point of worker, start event will be fired from here. Init some data and go to loop function for generating GPS data. Root GPS data will be generated in this function.","ref":"LocationSimulator.WorkerGpx.html#init/1"},{"type":"function","title":"LocationSimulator.WorkerGpx.start_link/1","doc":"Support for starting from supervisor.","ref":"LocationSimulator.WorkerGpx.html#start_link/1"},{"type":"extras","title":"README","doc":"LocationSimulator Use for simulating location/GPS (longitude, latitude, elevation) data. Support scalable for test workload. Source code is available on Github Package for using on Hex.pm","ref":"readme.html"},{"type":"extras","title":"README - Achitecture","doc":"The library has 3 main part: Supervisor. Lib uses PartitionSupervisor for creating worker from config Worker. Generating GPS with user config Callback module. This is defined by user to handle event from worker Api call flow sequenceDiagram participant CallbackModule participant Worker participant Api participant Supervisor Api-&gt;&gt;Supervisor: Start with workers from config Supervisor-&gt;&gt;Worker: Start GPS generator Worker-&gt;&gt;CallbackModule: call start event Worker-&gt;&gt;CallbackModule: call gps event Worker-&gt;&gt;CallbackModule: call stop event (for in local you need install extension support for mermaid to view flow)","ref":"readme.html#achitecture"},{"type":"extras","title":"README - Installation","doc":"Library can be installed by adding location_simulator to your list of dependencies in mix.exs : def deps do [ { :location_simulator , &quot;~&gt; 0.4&quot; } ] end Library need to start before using APIs. If you need start with your app, you could add to application function: def application do [ mod : { YourApp.Application , [ ] } , extra_applications : [ :logger , :location_simulator ] ] end If you need to modify source please go to Github and clone repo or contribute our repo.","ref":"readme.html#installation"},{"type":"extras","title":"README - Guide","doc":"Start LocationSimulator with default config: LocationSimulator . start ( ) With default config simulator will print location to console by Logger. Start with your callback &amp; config: Generate fake GPS data config = %{ worker : 3 , event : 100 , interval : 1000 , random_range : 0 , direction : :random , elevation : 100 , elevation_way : :up , callback : MyCallbackModule } LocationSimulator . start ( config ) Simulator support directions: :north, :south, :east, :west, :north_east, :north_west, :south_east, :south_west If :direction is missed or equal :random, simulator will random a direction for each worker. With elevation, you can set start level and way :up or :down or no move up/down by any value. If you want all worker started from same point, you can add :started_gps. In this case elevation config from outside will be ignored. config = %{ ... started_gps : { 20.95991288388162 , 107.06662537952286 , 0 } } Load GPS from GPX file For load GPS data just add a file path with supported wildcard by config gpx_file . Some configs are related to GPS can be ignored. config = %{ worker : 3 , interval : 1000 , gpx_file : &quot;data/*.gpx&quot; callback : MyCallbackModule } LocationSimulator . start ( config ) If you have multi GPX file matched with gpx_file worker will get file depended matched order and rotate if number of files is not enough for workers.","ref":"readme.html#guide"},{"type":"extras","title":"README - Example","doc":"Start library in Elixir's shell: mix deps.get iex -S mix iex(1)&gt; LocationSimulator.start() For writing callback module please go to LocationSimulator.Event document. We provide simple demo that generate a GPX file. You can get from repo","ref":"readme.html#example"}]